// DIRMP304.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"


#define		DIRLISTFILE				_T("\\DIRLST04.TXT")	// DIRR}h̏o͌(dir /AD /ON /S /N /B) 
#define		FILELISTFILE			_T("\\FILLST04.TXT")	// DIRR}h̏o͌(dir /B /ON fBNgpX)
#define		OUTFILE_DIRSTRUCT		_T("DIRLST04.DAT")		// DIR\t@C
#define		SNDFILELIST				_T("SNDLST04.DAT")		// t@CXg
#define		PITCHSHIFTER			_T("PSHFT131.DAT")		// VS10XX PITCH SHIFTER Rev1.31
#define		HISTFILE				_T("HIST04.DAT")		// t@C
#define		VOLUMEFILE				_T("VOLUME04.DAT")		// {[t@C
#define		ERRLOGFILE				_T("ERRLOG04.DAT")		// G[Ot@C
#define		ERRLOGFILE_BK			_T("ERRLOG04_BK.DAT")	// G[Ot@Ci܂̃G[Ot@C̃t@CŎcĂj

#define		DIRMP304LOG				_T("DIRMP304.LOG")
#define		RENAME04LOG				_T("RENDIR04.LOG")

#define		MAXLEN_DIRNAME			12			// DIR
#define		MAXLEN_DISPLAYNAME		32			// DIR̕\
#define		MAXLEN_TITLE			32			// Ȗ̕\

#define		BUFLEN					128
#define		MAX_DIRS				1000

typedef struct _DirList {
	TCHAR	fulldirbase[BUFLEN];		// DIRtpX(hCut)
	TCHAR	fulldir[BUFLEN];			// DIRtpX
	TCHAR	parentdir[BUFLEN];			// eDIRtpX
	TCHAR	dirname[MAXLEN_DIRNAME + 1];			// DIR
	TCHAR	displayname[MAXLEN_DISPLAYNAME + 1];	// DIR̕\
	USHORT	recno_subdir_start;		// TuDIRJns
	USHORT	num_subdir;				// TuDIR
	USHORT	recno_parentdir;		// eDIRs
	USHORT	recno_grandparentdir;	// eeDIRs
	USHORT	recno_nextrandomplay;	// _ĐÃR[hNo
	USHORT	row_dirlist_txt;		// DIRLIST.TXTs
	USHORT	num_sndfile;			// t@C
	TCHAR	filler[19];
} DIRLIST;

DIRLIST		DirList[MAX_DIRS];
USHORT		ShffuleWork[MAX_DIRS];
int			DirNameNum;

// DIR\t@C
#define	RECLEN_DIRLIST04	128UL
#define	MAXLEN_FILEPATH		60
#define MAXLEN_DIRPATH		(MAXLEN_FILEPATH - 13)		// 13 = 8.3 + ؂

typedef struct _DirList04 {
	TCHAR	fulldir[MAXLEN_FILEPATH + 1];	// DIRtpX
	TCHAR	lenfulldir;						// DIRtpX̒
	TCHAR	dirname[MAXLEN_DIRNAME + 1];	// DIR
	USHORT	recno_subdir_start;		// TuDIRJnR[hNo
	BYTE	num_subdir;				// TuDIR
	USHORT	recno_parentdir;		// eDIRR[hNo
	USHORT	recno_grandparentdir;	// eeDIRR[hNo
	USHORT	recno_nextrandomplay;	// _ĐÃR[hNo
	BYTE	num_sndfile;			// t@C
	TCHAR	displayname[MAXLEN_DISPLAYNAME + 1];			// fBNgLCD\
	TCHAR	filler[RECLEN_DIRLIST04];
} DIRLIST04;

// Œ蒷fBNgXg̃wb_R[h
typedef struct _DirListHead04 {
	USHORT	RecNum;				// R[hiwb_[R[h͊܂܂Ȃj
	USHORT	SndDirNum;			// MP3DIR
	TCHAR	filler[RECLEN_DIRLIST04];
} DIRLISTHEAD04;

// t@CXg
#define	RECLEN_MP3LIST04	64UL

typedef struct _Mp3List {
	TCHAR	FileName[13];
	TCHAR	TrackNo[3];
	TCHAR	TitleName[MAXLEN_TITLE + 1];
	TCHAR	filler[RECLEN_MP3LIST04];
} MP3LIST04;

// Đt@C
#define MAX_HIST_SIZE       100	// L^

typedef struct _HistFile  {
	USHORT		LastDir;		// ŌɍĐĂfBNg(0,1,2,...fBNg-1)
	USHORT		LastTrack;		// ŌɍĐĂ(1,2,...,Ȑ)
	ULONG		LastByte;		// ŌɍĐĂȂ̍ĐiioCgj

	USHORT		NextRandomDir;	// _ĐɂĎ̍ĐfBNg
	//USHORT		DirHist[MAX_HIST_SIZE];		// ĐfBNg̗
} HISTFILE04;

#define	RECLEN_HISTFILE04	sizeof(HISTFILE04)		// t@CR[h

// {[t@C

typedef struct _VolFile {
	UCHAR		Vol;		// {[l
	UCHAR		Count;		// fBNg̍Đ
} VOLFILE04;

#define RECLEN_VOLUMEFILE04		sizeof(VOLFILE04)

// G[Ot@C
#define RECLEN_ERRLOG04         8
#define MAX_ERRLOG_COUNT        1000

// VLSI SolutionJĂ"VS10XX PITCH SHIFTER"̌Œf[^
#define	PITCHSHIFTER131_SIZE		1373

const unsigned short PitchShifter131[PITCHSHIFTER131_SIZE] = { /* Compressed plugin */
  0x0007, 0x0001, 0x8030, 0x0006, 0x0006, 0x2800, 0xa2c0, 0x0000, /*    0 */
  0x0024, 0x2800, 0x68c0, 0x0007, 0x0001, 0x8010, 0x0006, 0x0006, /*    8 */
  0x2a10, 0x374e, 0x2a00, 0x0cce, 0x2a00, 0x270e, 0x0007, 0x0001, /*   10 */
  0x8033, 0x0006, 0x00d2, 0x3009, 0x3857, 0x3e18, 0x3822, 0x3e18, /*   18 */
  0x780a, 0x3e10, 0x3801, 0x48b2, 0x3855, 0x3e10, 0x3801, 0x0000, /*   20 */
  0x800a, 0x3e14, 0x3811, 0x3e14, 0xb813, 0x0006, 0x0013, 0x0023, /*   28 */
  0xffd1, 0x0006, 0x0192, 0x3009, 0x0800, 0x4080, 0x8c10, 0x0030, /*   30 */
  0x0552, 0x2800, 0x1c85, 0xf400, 0x4401, 0x0006, 0x0093, 0x3e10, /*   38 */
  0xb803, 0x3e01, 0x0c40, 0x4000, 0x8cc4, 0x4010, 0x8c02, 0x0000, /*   40 */
  0x0001, 0x6010, 0x4012, 0x0006, 0x0113, 0x2800, 0x1458, 0x6428, /*   48 */
  0x8c80, 0x0004, 0x0013, 0x3283, 0x0024, 0x0006, 0x0193, 0x3009, /*   50 */
  0x0203, 0x3009, 0x0c02, 0xfe26, 0x0024, 0x48b6, 0x8841, 0xfe42, /*   58 */
  0x0024, 0x4db6, 0x0024, 0xffb0, 0x4003, 0x48b2, 0x0024, 0xffa6, /*   60 */
  0x8203, 0x40b2, 0x8f82, 0x0030, 0x0555, 0x3d10, 0x4c80, 0xfe26, /*   68 */
  0x0024, 0x48b6, 0x8bc1, 0xfe42, 0x0024, 0x4db6, 0x0024, 0xffb0, /*   70 */
  0x4003, 0x48b2, 0x0024, 0xffa6, 0x1bc4, 0x40b2, 0x8c02, 0x4290, /*   78 */
  0x3401, 0x3009, 0x2f00, 0x2800, 0x1d55, 0x3009, 0x0c00, 0x4000, /*   80 */
  0x4401, 0x4100, 0x0024, 0x0000, 0x0001, 0x6014, 0x4010, 0x0004, /*   88 */
  0x0001, 0x2800, 0x1d58, 0x4010, 0x0024, 0x2800, 0x1d40, 0xf400, /*   90 */
  0x4010, 0x3e00, 0x8200, 0x3a10, 0x0200, 0x3a00, 0x3803, 0x0006, /*   98 */
  0x0152, 0x6104, 0x8b00, 0x6090, 0x8901, 0x6014, 0xa800, 0x0006, /*   a0 */
  0x6653, 0x2800, 0x2008, 0xb880, 0x4402, 0x3009, 0x2b80, 0x3009, /*   a8 */
  0x08c0, 0x4090, 0x4402, 0x3009, 0x2800, 0x0006, 0x0012, 0x3009, /*   b0 */
  0x2810, 0x3009, 0x0c01, 0x6214, 0x0024, 0x0006, 0x0092, 0x2800, /*   b8 */
  0x2258, 0x0000, 0x0100, 0x0004, 0x0001, 0x4214, 0x0024, 0x3009, /*   c0 */
  0x0801, 0x4112, 0x8c10, 0x6010, 0x020c, 0x6204, 0x020c, 0x3083, /*   c8 */
  0x1803, 0x2800, 0x2449, 0x36f0, 0x820c, 0x3009, 0x2c10, 0x36f4, /*   d0 */
  0x9813, 0x36f4, 0x1811, 0x36f0, 0x1801, 0x2210, 0x0000, 0x36f5, /*   d8 */
  0x4024, 0x36f0, 0x1801, 0x36f8, 0x580a, 0x36f8, 0x1822, 0x0030, /*   e0 */
  0x0717, 0x2100, 0x0000, 0x3f05, 0xdbd7, 0x0007, 0x0001, 0x809c, /*   e8 */
  0x0006, 0x00cc, 0x3009, 0x3853, 0x3e18, 0x3823, 0x3e18, 0x780a, /*   f0 */
  0x3e10, 0x3801, 0x48b2, 0x0024, 0x3e10, 0x3801, 0x0000, 0x800a, /*   f8 */
  0x3e10, 0xb803, 0x3e11, 0x3810, 0x3e04, 0x7812, 0x0006, 0x0010, /*  100 */
  0x0006, 0x0191, 0x3009, 0x0400, 0x4080, 0x8012, 0x0030, 0x0553, /*  108 */
  0x2800, 0x3445, 0x3009, 0x0840, 0x0006, 0x0093, 0x32f3, 0x0c40, /*  110 */
  0x4000, 0x4481, 0x4010, 0x8843, 0xf400, 0x4011, 0x0004, 0x0001, /*  118 */
  0x6014, 0x8cc4, 0x0030, 0x0550, 0x2800, 0x2e91, 0x3009, 0x0f82, /*  120 */
  0x0ffc, 0x0010, 0x3183, 0x0024, 0x0030, 0x0550, 0x6428, 0x184c, /*  128 */
  0xfe27, 0xe6e7, 0x48b6, 0x8447, 0xfe4e, 0x8c87, 0x4db6, 0x0024, /*  130 */
  0xffbe, 0x8bc3, 0x48b2, 0x0024, 0xffae, 0x8f82, 0x40b2, 0x0024, /*  138 */
  0xfe26, 0x2041, 0x48b6, 0x87c7, 0xfe4e, 0x0024, 0x4db6, 0x8c87, /*  140 */
  0xffbe, 0x0024, 0x48b2, 0x0024, 0xffae, 0x0024, 0x40b2, 0x8c02, /*  148 */
  0x4290, 0x2001, 0x3009, 0x2c00, 0x2800, 0x34d5, 0x36f1, 0x9807, /*  150 */
  0x2800, 0x34c0, 0xf400, 0x4452, 0x3b10, 0x0bc0, 0x3b00, 0x0024, /*  158 */
  0x0006, 0x0150, 0x3223, 0x0300, 0x6090, 0x8101, 0x6014, 0x4484, /*  160 */
  0x0004, 0x0001, 0x2800, 0x37c8, 0x6414, 0xa300, 0xb880, 0x810c, /*  168 */
  0x3009, 0x2380, 0x3009, 0x00c0, 0x4090, 0x4484, 0x6414, 0xa000, /*  170 */
  0x0006, 0x6651, 0x2800, 0x3951, 0x0006, 0x0010, 0x0ffc, 0x0013, /*  178 */
  0x3283, 0x0024, 0xf400, 0x4484, 0x3009, 0x0400, 0x6408, 0xa012, /*  180 */
  0x0000, 0x0400, 0x2800, 0x3b58, 0x6404, 0x8412, 0x0004, 0x0002, /*  188 */
  0x4428, 0x0024, 0x6404, 0x0024, 0x0000, 0x0413, 0x2800, 0x3dc8, /*  190 */
  0x3283, 0x0024, 0xf400, 0x4480, 0x6014, 0x0024, 0x0ffc, 0x0013, /*  198 */
  0x2800, 0x3d91, 0x0000, 0x0024, 0x3283, 0x0024, 0x3009, 0x2412, /*  1a0 */
  0x36f4, 0x5812, 0x36f1, 0x1810, 0x36f0, 0x9803, 0x36f0, 0x1801, /*  1a8 */
  0x2210, 0x0000, 0x36f0, 0x1801, 0x36f8, 0x580a, 0x36f8, 0x1823, /*  1b0 */
  0x0030, 0x0713, 0x2100, 0x0000, 0x3b04, 0xdbd3, 0x0007, 0x0001, /*  1b8 */
  0x8102, 0x0006, 0x0040, 0x3613, 0x0024, 0x3e12, 0x8024, 0x3e10, /*  1c0 */
  0xb803, 0x3e14, 0x3811, 0x3e14, 0xb813, 0x3e13, 0x780e, 0x3e03, /*  1c8 */
  0xc024, 0x0001, 0x000a, 0x0006, 0x0c15, 0x3504, 0x0024, 0x0020, /*  1d0 */
  0x0b91, 0x3880, 0x0024, 0x3880, 0x4024, 0xbd86, 0x3410, 0x0008, /*  1d8 */
  0x2b91, 0x0006, 0x02d2, 0x0000, 0x0053, 0x0000, 0x058e, 0x2400, /*  1e0 */
  0x458e, 0xfe25, 0x0829, 0x5017, 0x0829, 0x000e, 0x7b91, 0x5016, /*  1e8 */
  0x020c, 0x4db6, 0x0001, 0x4d16, 0x1bcf, 0xf1d6, 0x980e, 0xf7d0, /*  1f0 */
  0x1bcd, 0x36f4, 0x9813, 0x36f4, 0x1811, 0x36f0, 0x9803, 0x2000, /*  1f8 */
  0x0000, 0x36f2, 0x8024, 0x0007, 0x0001, 0x8122, 0x0006, 0x0102, /*  200 */
  0x3613, 0x0024, 0x3e12, 0xb817, 0x3e12, 0x3815, 0x3e05, 0xb814, /*  208 */
  0x3635, 0x0024, 0x0000, 0x800a, 0x3e10, 0x3801, 0x3e10, 0xb803, /*  210 */
  0x3e11, 0x3805, 0x3e11, 0xb810, 0x3e04, 0x7812, 0x34d3, 0x0024, /*  218 */
  0x3400, 0x0024, 0xf200, 0x1102, 0xf200, 0x0024, 0xf200, 0x0024, /*  220 */
  0x3cf0, 0x0024, 0x291d, 0x2400, 0x0000, 0x1600, 0x0000, 0x4001, /*  228 */
  0x6012, 0x108c, 0x3ce0, 0x0024, 0x2800, 0x4f49, 0x0000, 0x0386, /*  230 */
  0x0000, 0x4000, 0x3423, 0x0024, 0x3ce0, 0x0024, 0x0000, 0x0041, /*  238 */
  0x3413, 0x0024, 0x34b0, 0x8024, 0xfe22, 0x1100, 0x48b6, 0x0024, /*  240 */
  0xad66, 0x0024, 0xfe02, 0x0024, 0x293d, 0xc480, 0x48b2, 0x0024, /*  248 */
  0x4c8a, 0x104c, 0x0000, 0x0041, 0x34f0, 0x0024, 0xfe02, 0x0024, /*  250 */
  0x0000, 0xf001, 0x6eba, 0x0024, 0xf040, 0x0024, 0x6012, 0x0024, /*  258 */
  0x0000, 0x0041, 0x2800, 0x5748, 0x0000, 0xf002, 0xf040, 0x104c, /*  260 */
  0x3400, 0xc024, 0xfe26, 0x0024, 0x48b6, 0x0024, 0xfe02, 0x0024, /*  268 */
  0x293d, 0xc480, 0x48b2, 0x0024, 0x4480, 0x33c0, 0x0000, 0xf004, /*  270 */
  0x2800, 0x5758, 0x0000, 0x0024, 0x003f, 0x1004, 0x0000, 0x0041, /*  278 */
  0x0006, 0x0090, 0xb884, 0x108c, 0x6896, 0xa004, 0x34e0, 0x0024, /*  280 */
  0xfe02, 0x0024, 0x291d, 0x0580, 0x48b2, 0x0024, 0x0006, 0x0110, /*  288 */
  0x3423, 0x23c0, 0x34f0, 0x0024, 0x3410, 0x2380, 0xb880, 0xa140, /*  290 */
  0x3009, 0x23c0, 0x3009, 0x2340, 0x3009, 0x0000, 0x4080, 0x0024, /*  298 */
  0x0000, 0x0411, 0x2800, 0x5cd5, 0x0000, 0x0024, 0x2800, 0x64c0, /*  2a0 */
  0x3ce4, 0x4024, 0x4080, 0x138c, 0x0000, 0x0001, 0x2800, 0x6158, /*  2a8 */
  0x0006, 0x0011, 0x0000, 0x0400, 0x6090, 0x108c, 0x3ce0, 0x0400, /*  2b0 */
  0x6014, 0x0024, 0x0006, 0x6652, 0x2800, 0x6091, 0x0004, 0x0001, /*  2b8 */
  0x6014, 0x0024, 0x0000, 0x0024, 0x2800, 0x64d1, 0x0000, 0x0024, /*  2c0 */
  0x3009, 0x0800, 0x2800, 0x64c0, 0x3009, 0x2400, 0x0000, 0x0400, /*  2c8 */
  0x6090, 0x108c, 0x6090, 0x0024, 0x3ce0, 0x0400, 0x6014, 0x0024, /*  2d0 */
  0x0006, 0x6652, 0x2800, 0x6451, 0x0004, 0x0001, 0x6014, 0x0024, /*  2d8 */
  0x0000, 0x0024, 0x2800, 0x64d1, 0x0000, 0x0024, 0x3009, 0x0800, /*  2e0 */
  0x3009, 0x2400, 0x3613, 0x108c, 0x291a, 0x8040, 0x34e4, 0x3810, /*  2e8 */
  0x0000, 0x0810, 0x291a, 0x7f40, 0x3009, 0x1bcc, 0x36f4, 0x5812, /*  2f0 */
  0x36f1, 0x9810, 0x36f1, 0x1805, 0x36f0, 0x9803, 0x36f0, 0x1801, /*  2f8 */
  0x3405, 0x9014, 0x36f3, 0x0024, 0x36f2, 0x1815, 0x2000, 0x0000, /*  300 */
  0x36f2, 0x9817, 0x0007, 0x0001, 0x81a3, 0x0006, 0x0102, 0x3613, /*  308 */
  0x0024, 0x3e12, 0xb817, 0x3e12, 0x3815, 0x3e05, 0xb814, 0x3615, /*  310 */
  0x0024, 0x0000, 0x800a, 0x3e10, 0x3801, 0x3e10, 0xb803, 0x3e11, /*  318 */
  0x3805, 0x3e14, 0x3811, 0x0006, 0x9510, 0x0006, 0x01d1, 0x3e04, /*  320 */
  0xb813, 0x3009, 0x0000, 0x3009, 0x0401, 0x6014, 0x0024, 0x0030, /*  328 */
  0x0312, 0x2800, 0x7095, 0x0000, 0x0024, 0x3200, 0x044c, 0x3009, /*  330 */
  0x0401, 0x6014, 0x0024, 0x0006, 0x0292, 0x2800, 0x7095, 0x0006, /*  338 */
  0x9251, 0x3009, 0x0400, 0x3009, 0x0801, 0x6014, 0x0024, 0x0000, /*  340 */
  0x0024, 0x2800, 0x8685, 0x0000, 0x0024, 0x0030, 0x0311, 0x3100, /*  348 */
  0x0024, 0x4080, 0x0024, 0x0010, 0x0000, 0x2800, 0x7255, 0x0000, /*  350 */
  0x0024, 0x3900, 0x0024, 0x3100, 0x0024, 0x4080, 0x0024, 0x0001, /*  358 */
  0xffc0, 0x2800, 0x78d8, 0x0030, 0x00d2, 0x3201, 0x0024, 0xb408, /*  360 */
  0x0024, 0x0006, 0x01d3, 0x2800, 0x7515, 0x0001, 0xf400, 0x0001, /*  368 */
  0x0c04, 0x4408, 0x0401, 0x3613, 0x2004, 0x0006, 0x9250, 0x6810, /*  370 */
  0xac44, 0x3009, 0x2c81, 0x3e10, 0x0000, 0x2900, 0x4880, 0x3e00, /*  378 */
  0x2c00, 0x36e3, 0x0000, 0x6090, 0x0024, 0x3009, 0x2000, 0x3009, /*  380 */
  0x0005, 0x459a, 0x0024, 0x2900, 0x0b80, 0x0000, 0x8688, 0x3201, /*  388 */
  0x0024, 0xb408, 0x0024, 0x0000, 0x0081, 0x2800, 0x7a55, 0x0006, /*  390 */
  0x08d3, 0x0001, 0x0c04, 0x0001, 0xf400, 0x4408, 0x8c00, 0x6012, /*  398 */
  0x184c, 0x0004, 0x0003, 0x2800, 0x7c15, 0x0000, 0x0024, 0x4448, /*  3a0 */
  0x0024, 0xb885, 0xe1e0, 0x0000, 0x0041, 0x3100, 0x0024, 0xfe02, /*  3a8 */
  0x0024, 0x293d, 0xc480, 0x48b2, 0x0024, 0x0006, 0x08d1, 0x0006, /*  3b0 */
  0x01d0, 0xffc0, 0x1bcc, 0x48b2, 0x0024, 0x4cc2, 0x0024, 0x4cc2, /*  3b8 */
  0x0024, 0x3009, 0x2001, 0x0000, 0x0081, 0x3009, 0x0400, 0x6012, /*  3c0 */
  0x0024, 0x0006, 0x9253, 0x2800, 0x8295, 0x0030, 0x0312, 0x3200, /*  3c8 */
  0x404c, 0x3613, 0x2001, 0x3e10, 0x4c01, 0xf212, 0x0024, 0x3e00, /*  3d0 */
  0x4024, 0x2900, 0x4880, 0x0000, 0x83c8, 0x3200, 0x404c, 0x3613, /*  3d8 */
  0x2001, 0x3e10, 0x4c01, 0x2900, 0x4880, 0x3e00, 0x4024, 0x3023, /*  3e0 */
  0x0c00, 0x36e3, 0x2340, 0x3009, 0x0000, 0x0006, 0x9510, 0x3009, /*  3e8 */
  0x2000, 0x3009, 0x0c00, 0x6090, 0x0024, 0x3009, 0x2c00, 0x3009, /*  3f0 */
  0x0c05, 0x2900, 0x0b80, 0x459a, 0x0024, 0x36f4, 0x9813, 0x36f4, /*  3f8 */
  0x1811, 0x36f1, 0x1805, 0x36f0, 0x9803, 0x36f0, 0x1801, 0x3405, /*  400 */
  0x9014, 0x36f3, 0x0024, 0x36f2, 0x1815, 0x2000, 0x0000, 0x36f2, /*  408 */
  0x9817, 0x0007, 0x0001, 0x8224, 0x0006, 0x00ce, 0x3613, 0x0024, /*  410 */
  0x3e12, 0xb817, 0x3e12, 0x3815, 0x3e05, 0xb814, 0x3615, 0x0024, /*  418 */
  0x0000, 0x800a, 0x3e10, 0xb803, 0x4194, 0xb805, 0x3e11, 0x0024, /*  420 */
  0x3e14, 0x7812, 0x3e14, 0xf80d, 0x3e03, 0xf80e, 0x0000, 0x0003, /*  428 */
  0x2800, 0xa055, 0x0006, 0x9251, 0x002b, 0x1102, 0xb58a, 0x8404, /*  430 */
  0x6ed6, 0x0024, 0x0010, 0x0003, 0x2800, 0xa048, 0x0030, 0x0311, /*  438 */
  0x3100, 0x8024, 0x6236, 0x0024, 0x0000, 0x0024, 0x2800, 0x9e05, /*  440 */
  0x0000, 0x0024, 0x3100, 0x8024, 0x4284, 0x0024, 0x0006, 0x0c53, /*  448 */
  0x2800, 0x9e09, 0x0000, 0x0024, 0xf100, 0x0012, 0xb888, 0x4491, /*  450 */
  0x3300, 0x8024, 0x0006, 0x0c13, 0x6404, 0x2c02, 0x0000, 0x0024, /*  458 */
  0x2800, 0x9518, 0x4094, 0x0024, 0x2400, 0x9482, 0x3613, 0x0024, /*  460 */
  0x3220, 0x3840, 0x2900, 0x4080, 0x32e0, 0x7801, 0x3243, 0x1bc1, /*  468 */
  0x6498, 0x0024, 0x3920, 0x1800, 0x36f3, 0x0024, 0x0006, 0x0c13, /*  470 */
  0xb888, 0x0c02, 0x0006, 0x0c53, 0x3b10, 0x8024, 0x3004, 0x8024, /*  478 */
  0x3300, 0x884c, 0x0006, 0x0c13, 0x6404, 0x2c02, 0x0000, 0x0024, /*  480 */
  0x2800, 0x9a18, 0x4094, 0x4491, 0x2400, 0x9982, 0x3613, 0x0024, /*  488 */
  0x3220, 0x3840, 0x2900, 0x4080, 0x32e0, 0x7801, 0x3243, 0x1bc1, /*  490 */
  0x6498, 0x0024, 0x3920, 0x1800, 0x36f3, 0x0024, 0x0000, 0x0083, /*  498 */
  0x0006, 0x0c13, 0x3300, 0x984c, 0x0006, 0x0c93, 0x3b00, 0x8024, /*  4a0 */
  0x0006, 0x08d3, 0x3009, 0x0c02, 0x6236, 0x0024, 0x0000, 0x0082, /*  4a8 */
  0x2800, 0x9d85, 0x0000, 0x0024, 0xb884, 0xac02, 0x0006, 0x0293, /*  4b0 */
  0x3009, 0x2c02, 0x2800, 0xa040, 0x3009, 0x1bcc, 0x0006, 0x08d2, /*  4b8 */
  0x3613, 0x0802, 0x4294, 0x0024, 0x0006, 0x0293, 0x2800, 0xa005, /*  4c0 */
  0x6894, 0x0024, 0xb884, 0xa802, 0x3009, 0x2c02, 0x3009, 0x1bcc, /*  4c8 */
  0x36f3, 0xd80e, 0x36f4, 0xd80d, 0x36f4, 0x5812, 0x36f1, 0x1805, /*  4d0 */
  0x36f0, 0x9803, 0x3405, 0x9014, 0x36f3, 0x0024, 0x36f2, 0x1815, /*  4d8 */
  0x2000, 0x0000, 0x36f2, 0x9817, 0x0007, 0x0001, 0x828b, 0x0006, /*  4e0 */
  0x004a, 0x3613, 0x0024, 0x3e12, 0xb817, 0x3e12, 0x3815, 0x3e05, /*  4e8 */
  0xb814, 0x3615, 0x0024, 0x3e10, 0xb811, 0x0006, 0x7311, 0x3e14, /*  4f0 */
  0xb813, 0x0006, 0x0c52, 0x0006, 0x0c13, 0xb884, 0xb800, 0x3900, /*  4f8 */
  0x8024, 0x0006, 0x0002, 0x0000, 0x8911, 0x3e10, 0x4024, 0x3009, /*  500 */
  0x3850, 0x3009, 0x3810, 0x291a, 0x8040, 0x0000, 0x0c90, 0x0000, /*  508 */
  0x0010, 0x291a, 0x7f40, 0x3009, 0x1bcc, 0x3a10, 0x9bd0, 0x0006, /*  510 */
  0x1002, 0xb880, 0x1bc1, 0x3a00, 0x8024, 0x0006, 0x7312, 0x0006, /*  518 */
  0x0002, 0x3b00, 0x9813, 0x3a04, 0x4024, 0x36f4, 0x8024, 0x36f0, /*  520 */
  0x9811, 0x3405, 0x9014, 0x36f3, 0x0024, 0x36f2, 0x1815, 0x2000, /*  528 */
  0x0000, 0x36f2, 0x9817, 0x0007, 0x0001, 0x5800, 0x0006, 0x0005, /*  530 */
  0x0000, 0x0c00, 0x0000, 0x0100, 0x0100, 0x0006, 0x8006, 0x0000, /*  538 */
  0x0007, 0x0001, 0x580b, 0x0006, 0x0018, 0xffd8, 0x0052, 0xff62, /*  540 */
  0x0116, 0xfe3a, 0x02c3, 0xfbd5, 0x0633, 0xf6b8, 0x0e89, 0xe5ee, /*  548 */
  0x511e, 0x511e, 0xe5ee, 0x0e89, 0xf6b8, 0x0633, 0xfbd5, 0x02c3, /*  550 */
  0xfe3a, 0x0116, 0xff62, 0x0052, 0xffd8,
};


FILE	*FpLog;
BOOL	RenameErrFlg;
TCHAR	TempDir[MAX_PATH];

USHORT MakeSndFileList(TCHAR *inFolder, TCHAR *outAlbumName);
void GetMP3AlbumInfo(TCHAR *folder, TCHAR *sndfile, TCHAR *outAlbumName, TCHAR *outTitleName);
void AdjustDirAndFileNames(TCHAR *CurrentDir);
BOOL CheckName(TCHAR *name);
void MakeShortDirName(TCHAR *name, TCHAR *shortname);
BOOL HasMultibyteChar(TCHAR *str);
BOOL ConvertToSingleByteString(TCHAR *fromstr, TCHAR *tostr);
void GetNameBoforeRename(TCHAR *dir, TCHAR *oldname);


int _tmain(int argc, _TCHAR* argv[])
{
	FILE	*fin;
	FILE	*fout;
	TCHAR	buff[128];
	TCHAR	outfile[128];
	USHORT	rowin;
	USHORT	idxout;
	//int		dirid;
	USHORT	num;
	TCHAR	*c;
	TCHAR	*fullp;
	TCHAR	*parentp;
	TCHAR	*name;
	int		i;
	int		len;
	TCHAR			fulldirbase[BUFLEN];
	TCHAR			albumname[MAXLEN_DISPLAYNAME + 1];
	DIRLIST04		rec04;
	DIRLISTHEAD04	rech04;
	MP3LIST04		srec04;
	HISTFILE04		hrec04;
	USHORT			numsnddir;
	USHORT			dirno_last;
	int				shuffle_int;

	printf("fBNgƃt@Cꊇ8.3`ɕύX(\"go\" + EnterősȂŒ~)");
	if (_fgetts(buff, 128, stdin) == NULL) return 0;
	if (_tcsncmp(buff, _T("go"), 2) != 0) return 0;

	GetTempPath(MAX_PATH, TempDir);

	FpLog = _tfopen(DIRMP304LOG, _T("w"));

	// [gċAIɃtH_ƃt@CύXsvt@C폜
	RenameErrFlg = FALSE;
	AdjustDirAndFileNames(_T(""));
	if (RenameErrFlg == TRUE){
		printf("OύXoȂfBNg܂MP3t@CɂĂ͎ŖOύX邱!\n");
		printf("̌Ŗ{PGĎs\n");
		return 0;
	}

	// DIRR}h
	_stprintf(buff, "dir /AD /ON /S /N /B > %s%s", TempDir, DIRLISTFILE);
	_tsystem(buff);

	_stprintf(buff, "%s%s", TempDir, DIRLISTFILE);
	fin = _tfopen(buff, _T("rt"));
	if (fin == NULL){
		printf("cannot open input file\n");
		return 0;
	}

	numsnddir = 0;		// MP3t@CDIR
	rowin = 0;
	// [gfBNg̃Gg쐬
	idxout = 0;
	DirList[idxout].recno_subdir_start = 1;
	idxout++;

	while (_fgetts(buff, 128, fin) != NULL){
		// sR[h
		c = _tcschr(buff, '\r');
		c = _tcschr(buff, '\n');
		if (c != NULL){
			*c = '\0';
		}
		_tcscpy(fulldirbase, buff);
		// hCu
		if (buff[1] == ':') fullp = &buff[2];
		else fullp = buff;
		if (strlen(fullp) > MAXLEN_DIRPATH) continue;
		// fullp̓fBNg̃tpXłB
		// pXTufBNgƐefBNgpXƂɕ
		c = _tcsrchr(fullp, '\\');
		if (c != NULL){
			_tcscpy(DirList[idxout].fulldir, fullp);
			*c = '\0';
			name = c + 1;
			parentp = fullp;
			// pXTufBNgiLCD\p̃f[^Ȃ̂őOăXy[X߂Ăj
			memset(DirList[idxout].dirname, ' ', MAXLEN_DIRNAME);
			len = _tcslen(name);
			_tcsncpy(DirList[idxout].dirname, name, (len < MAXLEN_DIRNAME ? len : MAXLEN_DIRNAME));
			DirList[idxout].dirname[MAXLEN_DIRNAME] = '\0';
			// efBNgpX
			_tcscpy(DirList[idxout].fulldirbase, fulldirbase);
			_tcscpy(DirList[idxout].parentdir, parentp);

			// eDIRT
			for (i=0; i<idxout; i++){

				if (_tcscmp(DirList[idxout].parentdir, DirList[i].fulldir) == 0){
					if (DirList[i].num_subdir == 0){
						DirList[i].recno_subdir_start = idxout;	// eDIR̍ŏ̃TuDIR
					}
					DirList[i].num_subdir++;		// eDIR̃TuDIR
					DirList[idxout].recno_parentdir = i;		// eDIR̈ʒu
					DirList[idxout].recno_grandparentdir = DirList[i].recno_parentdir;	// eeDIR̈ʒu
					break;
				}
			}
			if (i == idxout){
				// eȂƂ̓[gDIR̂͂
				if (DirList[0].num_subdir == 0){
					DirList[0].recno_subdir_start = idxout;	// eDIR̍ŏ̃TuDIR
				}
				DirList[0].num_subdir++;
				DirList[idxout].recno_parentdir = 0;
				DirList[idxout].recno_grandparentdir = 0;
			}
			DirList[idxout].row_dirlist_txt = rowin;		// ̓t@C̍sʒu
			// t@CXg𐶐AoifBNg̕\j肷
			memset(albumname, 0, MAXLEN_DISPLAYNAME);
			memset(DirList[idxout].displayname, ' ', MAXLEN_DISPLAYNAME);
			DirList[idxout].num_sndfile = MakeSndFileList(DirList[idxout].fulldirbase, albumname);		// t@CXg𐶐
			//Ŏ擾Ao͎gȂƂɂB
			memset(albumname, 0, MAXLEN_DISPLAYNAME + 1);
			GetNameBoforeRename(DirList[idxout].fulldirbase, albumname);
			if (albumname[0] == '\0'){		// renameO̖O擾łȂƂ
				memcpy(DirList[idxout].displayname, DirList[idxout].dirname, _tcslen(DirList[idxout].dirname));
			} else {	
				if (HasMultibyteChar(albumname) == TRUE){		// renameO̖OQoCg܂
					memcpy(DirList[idxout].displayname, DirList[idxout].dirname, _tcslen(DirList[idxout].dirname));
				} else {
					memcpy(DirList[idxout].displayname, albumname, _tcslen(albumname));
				}
			}
			DirList[idxout].displayname[MAXLEN_DISPLAYNAME] = '\0';

			if (DirList[idxout].num_sndfile > 0){
				ShffuleWork[numsnddir] = idxout;		// _Đe[u
				numsnddir++;
			}

			rowin++;
			idxout++;
		}
	}
	fclose(fin);

	// _Đ
	shuffle_int = (numsnddir>10 ? 5 : 0);
	srand( (unsigned)time( NULL ) );
	for (i=0; i<(numsnddir*5); i++){
		int idx1, idx2;
		USHORT	d;

		idx1 = (rand() % numsnddir);
		while(1) {
			idx2 = (rand() % numsnddir);
			if (abs(idx2 - idx1) > shuffle_int) break;	// Ȃׂꂽ̓m
		}
		d = ShffuleWork[idx1];
		ShffuleWork[idx1] = ShffuleWork[idx2];
		ShffuleWork[idx2] = d;
	}
	for (i=0; i<numsnddir; i++) printf("%d ", ShffuleWork[i]);
	printf("\n");
	dirno_last = 0;
	for (i=0; i<numsnddir; i++){
		DirList[dirno_last].recno_nextrandomplay = ShffuleWork[i];
		dirno_last = ShffuleWork[i];
	}
	DirList[dirno_last].recno_nextrandomplay = DirList[0].recno_nextrandomplay;		// z

	// DIR\t@Co
	// OR[hڂ̓wb_R[h
	fout = _tfopen(OUTFILE_DIRSTRUCT, _T("wb"));
	rech04.RecNum = idxout;
	rech04.SndDirNum = numsnddir;
	memset(rech04.filler, '\0', RECLEN_DIRLIST04);
	fwrite(&rech04, RECLEN_DIRLIST04, 1, fout);		// wb_
	// PR[hڂ炪DIRR[hi̍ŏ̃R[h̓[gj
	for (i=0; i<idxout; i++){
		_tprintf(_T("%-12s %3d %04d %03d %04d %04d %04d %02d\n"), 
			DirList[i].dirname, i, DirList[i].recno_subdir_start, DirList[i].num_subdir, 
			DirList[i].recno_parentdir, DirList[i].recno_grandparentdir, DirList[i].recno_nextrandomplay, DirList[i].num_sndfile);

		memcpy(rec04.fulldir, DirList[i].fulldir, MAXLEN_FILEPATH + 1);
		rec04.lenfulldir = strlen(rec04.fulldir);
		memcpy(rec04.dirname, DirList[i].dirname, MAXLEN_DIRNAME + 1);
		if (DirList[i].recno_subdir_start == 0){	// TufBNg
			rec04.recno_subdir_start = 0;
		} else {
			rec04.recno_subdir_start = DirList[i].recno_subdir_start + 1;		// wb_R[h̕Z
		}
		if (DirList[i].num_subdir > 0x00FF){
			printf("TuDIR %s %d\n", rec04.fulldir, DirList[i].num_subdir);
			rec04.num_subdir = 0x00FF;		// ŏ̂QTTLɁB
			// ߂ĂĂ_Đ̑Ώۂɂ͂ȂB
			// DIRI@\őIłȂB
		} else {
			rec04.num_subdir = DirList[i].num_subdir;
		}
		rec04.recno_parentdir = DirList[i].recno_parentdir + 1;
		rec04.recno_grandparentdir = DirList[i].recno_grandparentdir + 1;
		rec04.recno_nextrandomplay = DirList[i].recno_nextrandomplay;
		rec04.num_sndfile = DirList[i].num_sndfile;
		memcpy(rec04.displayname, DirList[i].displayname, MAXLEN_DISPLAYNAME + 1);
		memset(rec04.filler, '\0', RECLEN_DIRLIST04);

		fwrite(&rec04, RECLEN_DIRLIST04, 1, fout);

	}
	fclose(fout);

	printf("#define DIRLIST04FILE            \"/%s\"\n", OUTFILE_DIRSTRUCT);
	printf("#define RECLEN_DIRLIST04         %dUL\n", RECLEN_DIRLIST04);
	printf("#define MAXLEN_FILEPATH          %dUL\n", MAXLEN_FILEPATH);
	printf("#define MAXLEN_DIRPATH           %dUL\n", MAXLEN_DIRPATH);
	printf("#define DL_FULLDIR               %d\n", &rec04.fulldir[0] - &rec04.fulldir[0]);
	printf("#define DL_LENFULLDIR            %d\n", &rec04.lenfulldir - &rec04.fulldir[0]);
	printf("#define DL_DIRNAME               %d\n", &rec04.dirname[0] - &rec04.fulldir[0]);
	printf("#define DL_RECNO_SUBDIR_START    %d\n", (long)&(rec04.recno_subdir_start) - (long)&(rec04.fulldir[0]));
	printf("#define DL_NUM_SUBDIR            %d\n", (long)&(rec04.num_subdir) - (long)&(rec04.fulldir[0]));
	printf("#define DL_RECNO_PARENTDIR       %d\n", (long)&(rec04.recno_parentdir) - (long)&(rec04.fulldir[0]));
	printf("#define DL_RECNO_GRANDPARENTDIR  %d\n", (long)&(rec04.recno_grandparentdir) - (long)&(rec04.fulldir[0]));
	printf("#define DL_RECNO_NEXTRANDOMDIR   %d\n", (long)&(rec04.recno_nextrandomplay) - (long)&(rec04.fulldir[0]));
	printf("#define DL_NUM_SNDFILE           %d\n", (long)&(rec04.num_sndfile) - (long)&(rec04.fulldir[0]));
	printf("#define DL_DISPLAYNAME           %d\n", (long)&(rec04.displayname) - (long)&(rec04.fulldir[0]));

	printf("\n");

	printf("#define SNDFILELIST04FILE        \"%s\"\n", SNDFILELIST);
	printf("#define RECLEN_MP3LIST04         %dUL\n", RECLEN_MP3LIST04);
	printf("#define ML_FILENAME              %d\n", &srec04.FileName[0] - &srec04.FileName[0]);
	printf("#define ML_TRACKNO               %d\n", &srec04.TrackNo[0] - &srec04.FileName[0]);
	printf("#define ML_TITLENAME             %d\n", &srec04.TitleName[0] - &srec04.FileName[0]);

	printf("\n");
	printf("#define VOLUME04FILE             \"%s\"\n", VOLUMEFILE);
	printf("#define RECLEN_VOLUME04          %dUL\n", RECLEN_VOLUMEFILE04);
	printf("#define VF_VOLUME                0\n");
	printf("#define VF_COUNT                 1\n");

	// PITCHSHIFTER
	fout = _tfopen(PITCHSHIFTER, _T("wb"));
	num = PITCHSHIFTER131_SIZE;
	fwrite(&num, 2, 1, fout);
	for (i=0; i<num; i++){
		fwrite(&PitchShifter131[i], 2, 1, fout);
	}
	fclose(fout);

	// HISTFILE
	fout = _tfopen(HISTFILE, _T("wb"));
	memset(&hrec04, 0, RECLEN_HISTFILE04);
	hrec04.LastDir = 0xFFFF;
	hrec04.LastTrack = 0xFFFF;
	hrec04.NextRandomDir = DirList[0].recno_nextrandomplay;
	fwrite(&hrec04, RECLEN_HISTFILE04, 1, fout);
	fclose(fout);

	printf("\n");
	printf("#define HIST04FILE                \"/%s\"\n", HISTFILE);
	printf("#define RECLEN_HISTFILE04         %dUL\n", RECLEN_HISTFILE04);
	printf("#define HS_LASTDIR                %d\n", (long)&hrec04.LastDir - (long)&hrec04);
	printf("#define HS_LASTTRACK              %d\n", (long)&hrec04.LastTrack - (long)&hrec04);
	printf("#define HS_LASTBYTE               %d\n", (long)&hrec04.LastByte - (long)&hrec04);
	printf("#define HS_NEXTRANDOMDIR          %d\n", (long)&hrec04.NextRandomDir - (long)&hrec04);

	// ERRLOGFILE
	fout = _tfopen(ERRLOGFILE, _T("wb"));
	memset(buff, 0, RECLEN_ERRLOG04);
	for (i=0; i<MAX_ERRLOG_COUNT; i++){
		fwrite(buff, RECLEN_ERRLOG04, 1, fout);
	}
	fclose(fout);

	printf("\n");
	printf("#define ERRLOG04FILE              \"/%s\"\n", ERRLOGFILE);
	printf("#define RECLEN_ERRLOG04           %dUL\n", RECLEN_ERRLOG04);
	printf("#define MAX_ERRLOG_COUNT          %d\n", MAX_ERRLOG_COUNT);

	_stprintf(buff, "copy %s %s", ERRLOGFILE, ERRLOGFILE_BK);
	_tsystem(buff);


	fclose(FpLog);

	return 0;
}


/*
 *	t@C(MP3)Xg쐬
 *		outAlbumName : Ao擾obt@(NULLI[̉ϒ(ő=MAXLEN_DISPLAYNAME)Ŏ擾)
 *		FindFirstFile/FindNextFile͕KOłȂ̂ŁAdirR}hɂ郊Xgō쐬B
 */
USHORT MakeSndFileList(TCHAR *inFolder, TCHAR *outAlbumName){
	FILE	*fin;
	FILE	*fout;
	TCHAR	outfile[128];
	TCHAR	filename[128];
	TCHAR	albumname[128];
	TCHAR	titlename[128];
	TCHAR	artistname[128];
	TCHAR	cFileName[MAX_PATH];
	TCHAR	buff[128];
	TCHAR	*c;
	HANDLE	handle;
	WIN32_FIND_DATA		finddata;
	USHORT	num = 0;
	MP3LIST04	rec04;
	BOOL	VolFileExist;
	int		trackno;
	TCHAR	tracknostr[8];
	int		i, len;

	trackno = 0;

	// 
#if 0
	_stprintf(filename, "%s\\*.*", inFolder);
	handle = FindFirstFile(filename, &finddata);	
	if (handle != INVALID_HANDLE_VALUE){
#else
	_stprintf(buff, "dir /B /A-D /ON %s > %s%s 2>NUL", inFolder, TempDir, FILELISTFILE);
	_tsystem(buff);

	_stprintf(buff, "%s%s", TempDir, FILELISTFILE);
	fin = _tfopen(buff, _T("rt"));
	if (fin != NULL){
#endif
		VolFileExist = FALSE;
		// o̓t@C
		_stprintf(outfile, _T("%s\\%s"), inFolder, SNDFILELIST);
		fout = _tfopen(outfile, _T("wb"));
		// o
#if 0
		do {
			_tcsncpy(cFileName, finddata.cFileName, MAX_PATH);
#else
		while (_fgetts(buff, 128, fin) != NULL){
			// sR[h
			c = _tcschr(buff, '\n');
			if (c != NULL){
				*c = '\0';
			}
			_tcsncpy(cFileName, buff, MAX_PATH);
#endif

			c = _tcsrchr(cFileName, '.');
			if (c != NULL){
				if (_tcsicmp(c, _T(".MP3")) == 0){
					if (CheckName(cFileName) == FALSE){
						continue;
					}
					if (num == 0x00FF){
						printf("MP3t@C %s\n", inFolder);
						break;
					}

					// Ao
					memset(albumname, 0, 128);
					memset(titlename, 0, 128);
					GetMP3AlbumInfo(inFolder, cFileName, albumname, titlename);
					if (num == 0){
						len = _tcslen(albumname);
						// ŏ̉t@CAo擾
						memcpy(outAlbumName, albumname, (len<MAXLEN_DISPLAYNAME ? len : MAXLEN_DISPLAYNAME));
						outAlbumName[(len<MAXLEN_DISPLAYNAME ? len : MAXLEN_DISPLAYNAME)] = '\0';
					}
					trackno++;

					memset(&rec04, 0, sizeof(MP3LIST04));
					// MP3t@C
					_tcsncpy(rec04.FileName, cFileName, 13);
					rec04.FileName[12] = '\0';
					// Ȕ
					_stprintf(tracknostr, "%03d", trackno);
					len = _tcslen(tracknostr);
					if (len <= 2){
						memcpy(rec04.TrackNo, tracknostr, len);
					} else {	// R̂Ƃ͉Q\
						rec04.TrackNo[0] = tracknostr[len - 2];
						rec04.TrackNo[1] = tracknostr[len - 1];
					}
					// \
					memset(rec04.TitleName, ' ', MAXLEN_TITLE);		// LCD\pɃXy[XŏĂ
					if (titlename[0] == '\0'){		// MP3t@CTAG^Cg擾łȂƂ̓t@Ĉ̂^Cgɂ
						memcpy(rec04.TitleName, rec04.FileName, _tcslen(rec04.FileName));
					} else {
						len = _tcslen(titlename);
						if (len > MAXLEN_TITLE) len = MAXLEN_TITLE;
						memcpy(rec04.TitleName, titlename, len);
					}
					// o
					fwrite(&rec04, RECLEN_MP3LIST04, 1, fout);
					num++;
				} else if (_tcsicmp(cFileName, VOLUMEFILE) == 0){
					VolFileExist = TRUE;
				}
			}
#if 0
		} while (FindNextFile(handle, &finddata));
#else
		}
#endif
		fclose(fout);

		//N[Y
#if 0
		FindClose(handle);
#else
		fclose(fin);
#endif
		// {[t@C
		if (VolFileExist == FALSE && num > 0){
			VOLFILE04	vrec04;
			vrec04.Vol = 0xFF;
			vrec04.Count = 0;

			_stprintf(outfile, _T("%s\\%s"), inFolder, VOLUMEFILE);
			fout = _tfopen(outfile, _T("wb"));
			fwrite(&vrec04, RECLEN_VOLUMEFILE04, 1, fout);
			fclose(fout);
		}
	}

	return num;
}

/*
 *	MP3t@C̃^O񂩂AoAȖ擾
 *		outAlbumName : Ao擾obt@(NULLI[̉ϒŎ擾)
 */
void GetMP3AlbumInfo(TCHAR *folder, TCHAR *sndfile, TCHAR *outAlbumName, TCHAR *outTitleName){
	TCHAR	titlenameBuf[MAXLEN_TITLE + 1];
	TCHAR	sndfilepath[128];
	unsigned char	data[1024];
	FILE	*fin;
	int		i, j, len;
	BOOL	flg1;

	memset(titlenameBuf, 0, MAXLEN_TITLE + 1);

	_stprintf(sndfilepath, "%s\\%s", folder, sndfile);
	fin = _tfopen(sndfilepath, _T("rb"));
	if (fin == NULL){
		fprintf(FpLog, _T("fopen error %s\\%s\n"), folder, sndfile);
		return;
	}
	fread(data, 1, 1024, fin);
	fclose(fin);

	if (data[0] == 'I' && data[1] == 'D' && data[2] == '3'){	// ID3
		if (data[3] == 0x02){		// v2.2
			for (i=10; i<1024; i++){
				if (data[i] == 'T'){
					if (data[i + 1] == 'T' && data[i + 2] == '2'){		// TT2
						if (data[i + 6] == 0x00){	// ISO-8859-1
							_tcsncpy(titlenameBuf, (const TCHAR *)&data[i + 7], MAXLEN_TITLE);
							titlenameBuf[MAXLEN_TITLE] = '\0';
							// search the end of TT2
							for (j=(i + 7); j<1024; j++){
								if (data[j] == 0x00){
									i = j;
									break;
								}
							}
						} else {		// UNICODE
							//_tprintf(_T("UNICODE TT2 : %s\n"), sndfile);
							// search the end of TT2
							for (j=(i + 7); j<1024; j+=2){
								if (data[j] == 0x00 && data[j + 1] == 0x00){
									i = j + 1;
									break;
								}
							}
						}
					} else if (data[i + 1] == 'A' && data[i + 2] == 'L'){	// TAL
						if (data[i + 6] == 0x00){	// ISO-8859-1
							_tcsncpy(outAlbumName, (const TCHAR *)&data[i + 7], MAXLEN_DISPLAYNAME);
							outAlbumName[MAXLEN_DISPLAYNAME] = '\0';
							// search the end of TT2
							for (j=(i + 7); j<1024; j++){
								if (data[j] == 0x00){
									i = j;
									break;
								}
							}
						} else {		// UNICODE
							//_tprintf(_T("UNICODE TT2 : %s\n"), sndfile);
							// search the end of TT2
							for (j=(i + 7); j<1024; j+=2){
								if (data[j] == 0x00 && data[j + 1] == 0x00){
									i = j + 1;
									break;
								}
							}
						}
					}
				}
			}
		} else if (data[3] == 0x03){	// v2.3
			for (i=10; i<1024; i++){
				if (data[i] == 'T'){
					if (data[i + 1] == 'I' && data[i + 2] == 'T'  && data[i + 3] == '2'){		// TIT2
						len = data[i + 7] - 1;

						memcpy(titlenameBuf, (const TCHAR *)&data[i + 11], (len < MAXLEN_TITLE ? len : MAXLEN_TITLE));
						titlenameBuf[MAXLEN_TITLE] = '\0';
						break;
					}
				}
			}
		}
	}

	flg1 = FALSE;

	for (i=0; i<MAXLEN_TITLE; i++){
		if ((titlenameBuf[i] & 0x80) != 0){		// {ꕶ܂
			flg1 = TRUE;
			break;
		}
	}
	if (flg1 == FALSE){		// {ꕶ܂܂Ȃ^Cg̗p
		memcpy(outTitleName, titlenameBuf, MAXLEN_TITLE);
	}

	_tprintf(_T("%s : %s\n"), sndfile, outTitleName);
	if (outTitleName[0] == 0){
		fprintf(FpLog, _T("Ȗs@%s\\%s\n"), folder, sndfile);
	}
}

/*
 *	ċAIDIRMP3t@C̕ύX@sB
 */
void AdjustDirAndFileNames(TCHAR *CurrentDir){
	TCHAR	buff[BUFLEN];
	TCHAR	filename[BUFLEN];
	TCHAR	oldfilepath[BUFLEN];
	TCHAR	oldname[BUFLEN];
	TCHAR	newname[BUFLEN];
	TCHAR	newfilepath[BUFLEN];
	HANDLE	handle;
	WIN32_FIND_DATA		finddata;
	TCHAR	*c;
	int		trackno = 1;
	FILE	*fin;

	// MP3̧ق̖OXg쐬(FindFirstFile/FindNextFileł͕KOɂȂȂ)
	_stprintf(buff, "dir /B /A-D /ON %s\\*.MP3 > %s%s 2>NUL", CurrentDir, TempDir, FILELISTFILE);
	_tsystem(buff);
	// MP3̧ق̖OύX
	_stprintf(buff, "%s%s", TempDir, FILELISTFILE);
	fin = _tfopen(buff, _T("rt"));
	if (fin != NULL){
		while (_fgetts(buff, 128, fin) != NULL){
			// sR[h
			c = _tcschr(buff, '\n');
			if (c != NULL){
				*c = '\0';
			}
			_stprintf(oldfilepath, "%s\\%s", CurrentDir, buff);
			_stprintf(newname, _T("%03d.MP3"), trackno++);
			_stprintf(newfilepath, "%s\\%s", CurrentDir, newname);
			if (_tcsicmp(buff, newname) != 0){
				if (rename(oldfilepath, newfilepath) != 0){
					_ftprintf(FpLog, "MP3@OύXs %s\n", oldfilepath);
					printf("MP3@OύXs %s\n", oldfilepath);
					RenameErrFlg = TRUE;
				}
			}
		}

		fclose(fin);
	}

	// TufBNg̖OύX
	_stprintf(filename, "%s\\*.*", CurrentDir);
	handle = FindFirstFile(filename, &finddata);
	if (handle != INVALID_HANDLE_VALUE){
		do {
			if (finddata.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
				if (_tcscmp(finddata.cFileName, _T(".")) != 0 && 
					_tcscmp(finddata.cFileName, _T("..")) != 0){

					// }`oCg\ȌVOoCgɕϊ
					_tcscpy(oldname, finddata.cFileName);
					_stprintf(oldfilepath, "%s\\%s", CurrentDir, oldname);
					if (HasMultibyteChar(oldname) == TRUE){
						if (ConvertToSingleByteString(oldname, newname) == TRUE){
							_stprintf(newfilepath, "%s\\%s", CurrentDir, newname);
							if (rename(oldfilepath, newfilepath) == 0){
								_tcscpy(oldname, newname);
								_stprintf(oldfilepath, "%s\\%s", CurrentDir, oldname);
							}
						}
					}

					if (HasMultibyteChar(oldname) == TRUE){
						_ftprintf(FpLog, "fBNg@}`oCg܂ %s\n", oldfilepath);
						printf("fBNg@}`oCg܂ %s\n", oldfilepath);
						RenameErrFlg = TRUE;
					} else {
						MakeShortDirName(oldname, newname);
						_stprintf(newfilepath, "%s\\%s", CurrentDir, newname);
						if (_tcsicmp(oldname, newname) == 0){
						} else if (rename(oldfilepath, newfilepath) == 0){
							// t@CύXÂOOɋL^ -> LCD̕\Ɏg
							FILE	*fprn;
							TCHAR	renamelog[BUFLEN];
							_stprintf(renamelog, "%s\\%s", newfilepath, RENAME04LOG);
							fprn = _tfopen(renamelog, _T("wt"));
							if (fprn != NULL){
								_ftprintf(fprn, "%s\n", oldname);
								fclose(fprn);
							}
						} else {
							_ftprintf(FpLog, "fBNg@OύXs %s\n", oldfilepath);
							printf("fBNg@OύXs %s\n", oldfilepath);
							RenameErrFlg = TRUE;
						}
					}
				}
			}
		} while (FindNextFile(handle, &finddata));

		//N[Y
		FindClose(handle);
	}

	// TufBNg̍ċAI
	_stprintf(filename, "%s\\*.*", CurrentDir);
	handle = FindFirstFile(filename, &finddata);
	if (handle != INVALID_HANDLE_VALUE){
		do {
			if (finddata.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
				if (_tcscmp(finddata.cFileName, _T(".")) != 0 && 
					_tcscmp(finddata.cFileName, _T("..")) != 0){

					_stprintf(newfilepath, "%s\\%s", CurrentDir, finddata.cFileName);
					AdjustDirAndFileNames(newfilepath);
				}
			}
		} while (FindNextFile(handle, &finddata));

		//N[Y
		FindClose(handle);
	}
}

/*
 *	Oname(1)8.3`(2)}`oCg܂܂ȂƂTRUE
 */
BOOL CheckName(TCHAR *name){
	TCHAR	*c;
	int		len;
	int		i;
	BOOL	hasMBC;

	c = _tcsrchr(name, '.');
	if (c != NULL){
		// gq̒mF
		if (_tcslen(c + 1) > 3) return FALSE;
		// Basename̒
		len = (int)(c - name);
	} else {	// gqȂ
		len = _tcslen(name);
	}
	// basename̒
	if (len > 8) return FALSE;

	hasMBC = HasMultibyteChar(name);
	if (hasMBC == TRUE) return FALSE;
	else return(TRUE);
}

/*
 *	}`oCg܂ނƂTRUEԂB
 */
BOOL HasMultibyteChar(TCHAR *str){
	int		i, j;
	int		len;

	len = _tcslen(str);

	for (i=0; i<len; i++){
		// }`oCg܂
		if (_ismbslead((unsigned char *)str, (unsigned char *)(str + i)) != 0){
			return TRUE;
		}
	}

	return FALSE;
}

/*
 *	񒆂̃}`oCgVOoCgɕϊ\ȂΕϊAϊs\ȕ͂̂܂܎cƂŐV쐬B
 *		PłϊłƂTRUEԂBFALSEԂƂ͑SϊłȂB
 */
BOOL ConvertToSingleByteString(TCHAR *fromstr, TCHAR *tostr){
	int		i, j;
	int		len;
	unsigned int	c1, c2;
	BOOL	ret;

	ret = FALSE;
	len = _tcslen(fromstr);
	j = 0;

	for (i=0; i<len; i++){
		// }`oCg܂
		if (_ismbslead((unsigned char *)fromstr, (unsigned char *)(fromstr + i)) != 0){
			c1 = ((unsigned char)fromstr[i] << 8) | (unsigned char)fromstr[i + 1];
			c2 = _mbctombb(c1);
			if (c2 != c1){
				tostr[j++] = c2;
				ret = TRUE;
			} else {
				tostr[j++] = fromstr[i];
				tostr[j++] = fromstr[i + 1];
			}
			i++;
		} else {
			tostr[j++] = fromstr[i];
		}
	}
	tostr[j++] = '\0';

	return ret;
}


/*
 *	fBNg̖Oname̒Zk𐶐
 */
void MakeShortDirName(TCHAR *name, TCHAR *shortname){
	int		i, j;
	int		len;
	BOOL	hasExtMBC;
	BOOL	hasMBC;
	TCHAR	*c;

	hasMBC = HasMultibyteChar(name);

	if (hasMBC == TRUE){
		// }`oCg܂ނƂ́AVO
		_stprintf(shortname, "%05ld", DirNameNum++);
	} else {
		len = _tcslen(name);

		for (i=0,j=0; i<len && j<8; i++){
			if (_istalnum((unsigned char)name[i]) != 0){
				shortname[j++] = name[i];
			}
		}
		shortname[j++] = '\0';
	}
}

/*
 *	renameÕfBNg擾
 */
void GetNameBoforeRename(TCHAR *dir, TCHAR *oldname){
	FILE	*fprn;
	TCHAR	renamelog[BUFLEN];
	TCHAR	buf[BUFLEN];
	TCHAR	*c;
	int		len;

	_stprintf(renamelog, "%s\\%s", dir, RENAME04LOG);
	fprn = _tfopen(renamelog, _T("rt"));
	if (fprn != NULL){
		_fgetts(buf, BUFLEN, fprn);
		c = _tcschr(buf, '\n');
		if (c != NULL){
			*c = '\0';
		}
		len = _tcslen(buf);
		memcpy(oldname, buf, (len<MAXLEN_DISPLAYNAME ? len : MAXLEN_DISPLAYNAME));
		oldname[(len<MAXLEN_DISPLAYNAME ? len : MAXLEN_DISPLAYNAME)] = '\0';

		fclose(fprn);
	}
}
